import { ImageAttrs, ImageProps } from './types';
interface IImageSize {
    naturalWidth: number;
    naturalHeight: number;
    ratio: number;
}
declare const getImageSize: (src: string) => Promise<IImageSize>;
declare const getImageFileList: (files: FileList) => any[];
declare const getInputImageFiles: (event: any) => any[];
declare const getSizeByRatio: (ratio: number, width?: number | undefined, height?: number | undefined) => {
    width?: number | undefined;
    height?: number | undefined;
};
declare const checkDomain: (src: string, config: ImageProps) => boolean;
declare const transformBlobFromObjectURL: (url: string) => Promise<Blob>;
declare const correctSize: (attrs: Partial<ImageAttrs>) => {
    width?: number | undefined;
    height?: number | undefined;
} | Promise<{
    width?: number | undefined;
    height?: number | undefined;
}>;
declare const constructAttrs: (oAttrs: Partial<ImageAttrs>, nAttrs: Partial<ImageAttrs>) => Promise<Partial<ImageAttrs>>;
export { checkDomain, constructAttrs, correctSize, getImageFileList, getImageSize, getInputImageFiles, getSizeByRatio, transformBlobFromObjectURL, };
