import { InlineAtom, SylApi, SylController, SylPlugin } from '@syllepsis/adapter';
import { DOMOutputSpec, Node } from 'prosemirror-model';
interface ILinkProps {
    validateHref: (value: string) => {
        error: boolean;
        text?: string;
        href?: string;
    };
}
interface ILinkAttrs {
    text: string;
    href: string;
}
declare class LinkController extends SylController<ILinkProps> {
    name: string;
    validateHref: (value: string) => {
        error: boolean;
    };
    toolbar: {
        handler: (editor: SylApi) => void;
    };
    insert: (attrs: any) => void;
    constructor(editor: SylApi, props: ILinkProps);
}
declare class Link extends InlineAtom<ILinkAttrs> {
    name: string;
    tagName: () => string;
    attrs: {
        href: {
            default: string;
        };
        text: {
            default: string;
        };
    };
    getText: boolean;
    textMatcher: {
        matcher: RegExp;
        handler(match: string[]): {
            text: string;
            href: string;
        };
    }[];
    parseDOM: {
        tag: string;
        getAttrs(dom: HTMLAnchorElement): any;
    }[];
    toDOM: (node: Node) => DOMOutputSpec;
}
declare class LinkPlugin extends SylPlugin<ILinkProps> {
    name: string;
    Controller: typeof LinkController;
    Schema: typeof Link;
}
export { ILinkProps, Link, LinkController, LinkPlugin };
