import { Block, SylApi, SylController, SylPlugin } from '@syllepsis/adapter';
import { Node as ProseMirrorNode } from 'prosemirror-model';
import { IUserAttrsConfig } from '../../utils';
interface IHeaderProps {
    addAttributes?: IUserAttrsConfig;
}
interface IHeaderStructure {
    level: number;
}
declare class Header extends Block<IHeaderStructure> {
    name: string;
    tagName: (node: any) => string;
    parseFromDOM: (dom: HTMLElement) => false | {
        level: number;
    };
    constructor(editor: SylApi, props: IHeaderProps);
    textMatcher: {
        matcher: RegExp;
        handler(match: RegExpExecArray): {
            level: number;
        };
    }[];
    attrs: {
        level: {
            default: number;
        };
    };
    parseDOM: {
        tag: string;
        getAttrs: (dom: HTMLElement) => false | {
            level: number;
        };
    }[];
    toDOM: (node: ProseMirrorNode) => readonly [`h${any}`, {
        [x: string]: any;
    }, 0];
}
declare class HeaderController extends SylController {
    name: string;
    toolbar: {
        className: string;
        tooltip: string;
        type: string;
        value: ({
            attrs: boolean;
        } | {
            attrs: {
                level: number;
            };
        })[];
    };
}
declare class HeaderPlugin extends SylPlugin<IHeaderProps> {
    name: string;
    Controller: typeof HeaderController;
    Schema: typeof Header;
}
export { Header, HeaderController, HeaderPlugin };
