var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { Block, SylController, SylPlugin } from '@syllepsis/adapter';
import { addAttrsByConfig, getFromDOMByConfig, setDOMAttrByConfig } from '../../utils';
var NAME = 'header';
var Header = /** @class */ (function (_super) {
    __extends(Header, _super);
    function Header(editor, props) {
        var _this = _super.call(this, editor, props) || this;
        _this.name = NAME;
        _this.tagName = function (node) { return "h" + ((node && node.attrs.level) || 1); };
        _this.parseFromDOM = function (dom) {
            var level = dom.tagName.match(/\d/);
            if (!level)
                return false;
            var attrs = { level: +level[0] };
            getFromDOMByConfig(_this.props.addAttributes, dom, attrs);
            return attrs;
        };
        _this.textMatcher = [
            {
                matcher: /^(#{1,6})\s$/,
                handler: function (match) {
                    return {
                        level: match[1].length,
                    };
                },
            },
        ];
        _this.attrs = {
            level: {
                default: 1,
            },
        };
        _this.parseDOM = [
            { tag: 'h1', getAttrs: _this.parseFromDOM },
            { tag: 'h2', getAttrs: _this.parseFromDOM },
            { tag: 'h3', getAttrs: _this.parseFromDOM },
            { tag: 'h4', getAttrs: _this.parseFromDOM },
            { tag: 'h5', getAttrs: _this.parseFromDOM },
            { tag: 'h6', getAttrs: _this.parseFromDOM },
        ];
        _this.toDOM = function (node) {
            var attrs = __assign({}, node.attrs);
            setDOMAttrByConfig(_this.props.addAttributes, node, attrs);
            return ["h" + attrs.level, attrs, 0];
        };
        if (props.addAttributes) {
            addAttrsByConfig(props.addAttributes, _this);
        }
        return _this;
    }
    return Header;
}(Block));
var HeaderController = /** @class */ (function (_super) {
    __extends(HeaderController, _super);
    function HeaderController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = NAME;
        _this.toolbar = {
            className: 'header',
            tooltip: 'header',
            type: 'select',
            value: [
                {
                    attrs: false,
                },
                {
                    attrs: { level: 1 },
                },
                {
                    attrs: { level: 2 },
                },
                {
                    attrs: { level: 3 },
                },
            ],
        };
        return _this;
    }
    return HeaderController;
}(SylController));
var HeaderPlugin = /** @class */ (function (_super) {
    __extends(HeaderPlugin, _super);
    function HeaderPlugin() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = NAME;
        _this.Controller = HeaderController;
        _this.Schema = Header;
        return _this;
    }
    return HeaderPlugin;
}(SylPlugin));
export { Header, HeaderController, HeaderPlugin };
//# sourceMappingURL=index.js.map