import { Block, SylController, SylPlugin } from '@syllepsis/adapter';
interface IOrderedListAttrs {
    start: number;
}
declare class OrderedList extends Block<IOrderedListAttrs> {
    name: string;
    role: string;
    content: string;
    tagName: () => string;
    attrs: {
        start: {
            default: number;
        };
    };
    textMatcher: {
        matcher: RegExp;
        handler(match: RegExpExecArray): {
            start: string;
        };
    }[];
    parseDOM: {
        tag: string;
        getAttrs(dom: HTMLOListElement): {
            start: number;
        };
    }[];
}
declare class OrderedListController extends SylController {
    name: string;
    toolbar: {
        className: string;
        tooltip: string;
    };
}
declare class OrderedListPlugin extends SylPlugin {
    name: string;
    Controller: typeof OrderedListController;
    Schema: typeof OrderedList;
}
export { OrderedList, OrderedListController, OrderedListPlugin };
