import { Inline, SylApi, SylController, SylPlugin } from '@syllepsis/adapter';
import { DOMOutputSpec, Node } from 'prosemirror-model';
interface IBackgroundProps {
    default?: string;
    transparent?: boolean;
}
interface IBackgroundAttrs {
    color: string | null;
}
declare class Background extends Inline<IBackgroundAttrs> {
    name: string;
    tagName: () => string;
    constructor(editor: SylApi, props: IBackgroundProps);
    attrs: {
        color: {
            default: string;
        };
    };
    getAttrs: (style: string) => false | {
        color: string;
    };
    parseDOM: {
        style: string;
        getAttrs: (style: string) => false | {
            color: string;
        };
    }[];
    toDOM: (node: Node) => DOMOutputSpec;
}
declare class BackgroundController extends SylController<IBackgroundProps> {
    name: string;
    defaultColor: string;
    constructor(editor: SylApi, props: IBackgroundProps);
    getAttrs: (color: string) => false | {
        color: string;
    };
    getValue: (attrs: any) => any;
    toolbar: SylController['toolbar'];
    disable: (editor: SylApi) => boolean;
}
declare class BackgroundPlugin extends SylPlugin<IBackgroundProps> {
    name: string;
    Controller: typeof BackgroundController;
    Schema: typeof Background;
}
export { Background, BackgroundController, BackgroundPlugin };
