var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Inline, SylController, SylPlugin } from '@syllepsis/adapter';
import { checkMarkDisable, keymapToggleMark } from '../../utils';
var STRIKE_PATTERN = /line-through/i;
var NAME = 'strike';
var toggleStrike = keymapToggleMark(NAME);
var getAttrs = function (value) {
    if (STRIKE_PATTERN.test(value)) {
        return true;
    }
    return false;
};
var Strike = /** @class */ (function (_super) {
    __extends(Strike, _super);
    function Strike() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = NAME;
        _this.tagName = function () { return 's'; };
        _this.textMatcher = [
            {
                matcher: /~~([^~]+)~~\s$/,
            },
        ];
        _this.parseDOM = [
            { tag: 's', priority: 25 },
            { tag: 'strike', priority: 25 },
            { tag: 'del', priority: 25 },
            {
                style: 'text-decoration-line',
                getAttrs: getAttrs,
            },
        ];
        return _this;
    }
    return Strike;
}(Inline));
var StrikeController = /** @class */ (function (_super) {
    __extends(StrikeController, _super);
    function StrikeController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = NAME;
        _this.keymap = {
            'Mod-d': toggleStrike,
            'Mod-D': toggleStrike,
        };
        _this.disable = function (editor) { return checkMarkDisable(editor.view, NAME); };
        return _this;
    }
    return StrikeController;
}(SylController));
var StrikePlugin = /** @class */ (function (_super) {
    __extends(StrikePlugin, _super);
    function StrikePlugin() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = NAME;
        _this.Controller = StrikeController;
        _this.Schema = Strike;
        return _this;
    }
    return StrikePlugin;
}(SylPlugin));
export { Strike, StrikeController, StrikePlugin };
//# sourceMappingURL=index.js.map