import { Paragraph as BaseParagraph, SylApi, SylPlugin } from '@syllepsis/adapter';
import { DOMOutputSpecArray, Node as ProseMirrorNode } from 'prosemirror-model';
import { constructTypesetParseDOM, ITypesetProps, IUserAttrsConfig } from '../../utils';
interface IParagraphProps extends ITypesetProps {
    addMatchTags?: string[];
    canMatch?: (dom: HTMLElement) => boolean;
    allowedClass?: string[];
    addAttributes?: IUserAttrsConfig;
}
declare class Paragraph extends BaseParagraph {
    toDOMAttrs: {};
    formatAttrs: ReturnType<typeof constructTypesetParseDOM>['formatAttrs'];
    defaultFontSize: number;
    editor: SylApi;
    constructor(editor: SylApi, props: IParagraphProps);
    constructParseDOM: (config: IParagraphProps) => void;
    toDOM: (node: ProseMirrorNode) => DOMOutputSpecArray;
}
declare class ParagraphPlugin extends SylPlugin<IParagraphProps> {
    name: string;
    Schema: typeof Paragraph;
}
export { Paragraph, ParagraphPlugin };
