"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypesetController = void 0;
var adapter_1 = require("@syllepsis/adapter");
var prosemirror_state_1 = require("prosemirror-state");
var utils_1 = require("../../../utils");
var TypesetController = /** @class */ (function (_super) {
    __extends(TypesetController, _super);
    function TypesetController() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.name = '';
        _this.attrName = '';
        _this.toolbar = {
            type: 'dropdown',
            value: [],
            handler: function (editor, name, attrs) { return _this.command.setStyle(editor, attrs); },
            getAttrs: function (editor) {
                var _a;
                var node = editor.view.state.selection.$from.node();
                var attr = node.attrs[_this.attrName];
                if (attr === '')
                    return '';
                return _a = {}, _a[_this.attrName] = +attr, _a;
            }
        };
        _this.constructValue = function (props) {
            var _a;
            var cValues = props.values;
            if (!cValues)
                return;
            _this.toolbar.value = [];
            if (props.values) {
                if (!_this.attrName)
                    _this.attrName = _this.name.replace(/_(.)/, function ($0, $1) { return $1.toUpperCase(); });
                _this.toolbar.value = (0, utils_1.formatMenuValues)(_this.attrName, props.values, (_a = {}, _a[_this.attrName] = '', _a));
            }
        };
        _this.command = {
            setStyle: function (editor, attrs) {
                editor.nodesBetween(function (node, nodePos) {
                    if (node.isTextblock) {
                        editor.update(attrs, nodePos);
                        return false;
                    }
                    return true;
                });
                editor.focus();
            }
        };
        _this.disable = function (editor) {
            var selection = editor.view.state.selection;
            return !(selection instanceof prosemirror_state_1.AllSelection) && !(0, utils_1.checkParentSupportAttr)(editor.view, _this.attrName);
        };
        return _this;
    }
    return TypesetController;
}(adapter_1.SylController));
exports.TypesetController = TypesetController;
//# sourceMappingURL=index.js.map