import { SylApi, SylController, SylPlugin, Types } from '@syllepsis/adapter';
declare module '@syllepsis/adapter' {
    interface ISylApiCommand {
        format_painter?: {
            applyFormat: () => void;
            collectFormat: () => void;
        };
    }
}
interface IFormatPainterProps {
    ignoreNodes?: string[];
    ignoreMarks?: string[];
    addNodes?: string[];
    addMarks?: string[];
}
declare class FormatPainterController extends SylController<IFormatPainterProps> {
    name: string;
    editor: SylApi;
    props: Required<IFormatPainterProps>;
    _isApply: boolean;
    _isContinuosApply: boolean;
    setCursor(): void;
    removeCursor(): void;
    get isApply(): boolean;
    set isApply(val: boolean);
    get isContinuosApply(): boolean;
    set isContinuosApply(val: boolean);
    stopApply: () => void;
    stopApplyOnEsc: (e: KeyboardEvent) => void;
    collectMarks: Types.StringMap<any>;
    collectNodes: Types.StringMap<any>;
    stashFormat: {
        marks: Types.StringMap<any>;
        nodeAttrs: Types.StringMap<any>;
    };
    constructor(editor: SylApi, props: IFormatPainterProps);
    constructCollectInfo: () => void;
    active: () => boolean;
    collectFormat: () => void;
    applyFormat: () => void;
    _applyFormat(): void;
    singleApply: () => void;
    toolbar: {
        handler: () => void;
    };
    buttonProps: {
        onDoubleClick: () => void;
    };
    command: {
        collectFormat: () => void;
        applyFormat: () => void;
    };
}
declare class FormatPainterPlugin extends SylPlugin<IFormatPainterProps> {
    name: string;
    Controller: typeof FormatPainterController;
}
export { FormatPainterController, FormatPainterPlugin };
