import { SylApi, SylController, SylPlugin, Types } from '@syllepsis/adapter';
declare module '@syllepsis/adapter' {
    interface ISylApiCommand {
        line_indent?: {
            setStyle: (attrs: {
                lineIndent: string | number;
            }) => void;
        };
    }
}
interface ILineIndentProps {
    value: number;
}
declare class LineIndentController extends SylController<ILineIndentProps> {
    attrName: string;
    toolbar: {
        handler: (editor: SylApi) => void;
    };
    command: {
        setTypeset: (editor: SylApi, attrs: Types.StringMap<any>) => void;
    };
    active: (editor: SylApi) => boolean;
    disable: (editor: SylApi) => boolean;
}
declare class LineIndentPlugin extends SylPlugin<ILineIndentProps> {
    name: string;
    Controller: typeof LineIndentController;
}
export { LineIndentController, LineIndentPlugin };
