import { Inline, SylApi, SylController, SylPlugin } from '@syllepsis/adapter';
import { DOMOutputSpec, Node } from 'prosemirror-model';
interface IColorAttrs {
    color: string;
}
interface IColorProps {
    default?: string;
    transparent?: boolean;
}
declare class Color extends Inline<IColorAttrs> {
    name: string;
    tagName: () => string;
    constructor(editor: SylApi, props: IColorProps);
    attrs: {
        color: {
            default: string;
        };
    };
    parseDOM: ({
        style: string;
        getAttrs: (val: string) => false | {
            color: string;
        };
        tag?: undefined;
    } | {
        tag: string;
        getAttrs: (dom: HTMLElement) => false | {
            color: string;
        };
        style?: undefined;
    })[];
    toDOM: (node: Node) => DOMOutputSpec;
}
declare class ColorController extends SylController<IColorProps> {
    name: string;
    defaultColor: string;
    constructor(editor: SylApi, props: IColorProps);
    getAttrs: (color: string) => false | {
        color: string;
    };
    getValue: (attrs: any) => any;
    disable: (editor: SylApi) => boolean;
    toolbar: SylController['toolbar'];
}
declare class ColorPlugin extends SylPlugin<IColorProps> {
    name: string;
    Controller: typeof ColorController;
    Schema: typeof Color;
}
export { Color, ColorController, ColorPlugin };
