import { Inline, SylApi, SylController, SylPlugin } from '@syllepsis/adapter';
import { DOMOutputSpec, Node } from 'prosemirror-model';
import { getFormatAttrsByValue, TAllowedValuesConfig, TValuesConfig } from '../../utils';
interface ILetterSpaceAttrs {
    space: string | number;
}
interface ILetterSpaceProps {
    allowedValues?: TAllowedValuesConfig;
    defaultFontSize?: number;
    values?: TValuesConfig;
}
declare class LetterSpace extends Inline<ILetterSpaceAttrs> {
    name: string;
    tagName: () => string;
    formatAttrs: ReturnType<typeof getFormatAttrsByValue>['formatAttrs'];
    defaultFontSize: number;
    private defaultValue;
    constructor(editor: SylApi, props: ILetterSpaceProps);
    constructParseDOM(config: ILetterSpaceProps): void;
    attrs: {
        space: {
            default: string;
        };
    };
    parseDOM: {
        style: string;
        getAttrs: (style: string) => false | {
            [x: string]: string | number | undefined;
        };
    }[];
    toDOM: (node: Node) => DOMOutputSpec;
}
declare class LetterSpaceController extends SylController<ILetterSpaceProps> {
    name: string;
    constructor(editor: SylApi, props: ILetterSpaceProps);
    constructValue: (props: ILetterSpaceProps) => void;
    toolbar: {
        className: string;
        tooltip: string;
        type: string;
        value: ({
            attrs: boolean;
            text: string;
        } | {
            attrs: {
                space: number;
            };
            text: string;
        })[];
    };
    disable: (editor: SylApi) => boolean;
}
declare class LetterSpacePlugin extends SylPlugin<ILetterSpaceProps> {
    name: string;
    Schema: typeof LetterSpace;
    Controller: typeof LetterSpaceController;
}
export { LetterSpace, LetterSpaceController, LetterSpacePlugin };
