"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.toHex = void 0;
var color_1 = __importDefault(require("color"));
var STATIC_COLOR = {
    black: '#000000',
    silver: '#C0C0C0',
    gray: '#808080',
    white: '#FFFFFF',
    maroon: '#800000',
    red: '#FF0000',
    purple: '#800080',
    fuchsia: '#FF00FF',
    green: '#008000',
    lime: '#00FF00',
    olive: '#808000',
    yellow: '#FFFF00',
    navy: '#000080',
    blue: '#0000FF',
    teal: '#008080',
    aqua: '#00FFFF',
};
var toHexAlpha = function (val) {
    if (val === 1)
        return '';
    if (!val)
        return '00';
    return parseInt("" + 255 * val, 10)
        .toString(16)
        .toUpperCase();
};
// covert color-string to #xxxxxx
var toHex = function (_color, alpha) {
    if (alpha === void 0) { alpha = true; }
    try {
        if (STATIC_COLOR[_color])
            return STATIC_COLOR[_color];
        var color = (0, color_1.default)(_color);
        return color.hex() + (alpha ? toHexAlpha(color.alpha()) : '');
    }
    catch (e) {
        return '';
    }
};
exports.toHex = toHex;
//# sourceMappingURL=color.js.map