import { SylApi, Types } from '@syllepsis/adapter';
import { Node as ProsemirrorNode } from 'prosemirror-model';
import { EditorView } from 'prosemirror-view';
declare const getMarkDisable: (excludeMarks: string | undefined, markName: string) => boolean;
declare const checkMarkDisable: (view: EditorView, markName: string) => boolean;
declare const checkParentSupportAttr: (view: EditorView, attrName: string) => boolean;
declare const setAlign: (view: EditorView, align: 'left' | 'center' | 'right' | 'justify', inclusive?: boolean) => boolean;
declare const checkParentHaveAttr: (view: EditorView, attrName: string, attrVal: string) => boolean;
declare type IUserAttrsConfig = Types.StringMap<{
    default: any;
    [key: string]: any;
    getFromDOM: (dom: HTMLElement) => any | void | undefined;
    setDOMAttr: (value: string, attrs: Types.StringMap<any>) => void;
}>;
declare const addAttrsByConfig: (config: IUserAttrsConfig | undefined, schema: Types.StringMap<any>) => void;
declare const getFromDOMByConfig: (config: IUserAttrsConfig | undefined, dom: HTMLElement, parseAttrs: Types.StringMap<any>) => void;
declare const setDOMAttrByConfig: (config: IUserAttrsConfig | undefined, node: ProsemirrorNode, attrs: Types.StringMap<any>) => void;
declare const getFixSize: (num: number, count?: number) => number;
declare const createFileInput: ({ multiple, accept, onChange, getContainer, }: {
    multiple: boolean;
    accept: string;
    onChange: (e: Event) => void;
    getContainer: () => HTMLElement;
}) => HTMLInputElement;
declare const isMatchObject: (objStatic: any, objCompare: any) => boolean;
declare const keymapToggleMark: (name: string) => (editor: SylApi) => boolean;
declare const simpleUploadHandler: (config: {
    name: string;
    target: HTMLInputElement;
    uploader: (file: File, editor: SylApi) => Promise<any>;
    uploadBeforeInsert: boolean;
    editor: SylApi;
    getAttrs: (url: string, file: File) => Record<string, any>;
}) => Promise<void>;
export { addAttrsByConfig, checkMarkDisable, checkParentHaveAttr, checkParentSupportAttr, createFileInput, getFixSize, getFromDOMByConfig, getMarkDisable, isMatchObject, IUserAttrsConfig, keymapToggleMark, setAlign, setDOMAttrByConfig, simpleUploadHandler, };
