"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.simpleUploadHandler = exports.setDOMAttrByConfig = exports.setAlign = exports.keymapToggleMark = exports.isMatchObject = exports.getMarkDisable = exports.getFromDOMByConfig = exports.getFixSize = exports.createFileInput = exports.checkParentSupportAttr = exports.checkParentHaveAttr = exports.checkMarkDisable = exports.addAttrsByConfig = void 0;
var prosemirror_state_1 = require("prosemirror-state");
var getMarkDisable = function (excludeMarks, markName) {
    if (!excludeMarks)
        return false;
    if (excludeMarks === '_')
        return true;
    if (excludeMarks.split(/\s/).includes(markName))
        return true;
    return false;
};
exports.getMarkDisable = getMarkDisable;
var checkMarkDisable = function (view, markName) {
    var $from = view.state.selection.$from;
    if ($from.parent.type.spec.code)
        return true;
    var excludeMarks = $from.parent.type.spec.excludeMarks;
    if (!getMarkDisable(excludeMarks, markName)) {
        if ($from.depth > 1) {
            var parentExcludeMarks = $from.node($from.depth - 1).type.spec.excludeMarks;
            return getMarkDisable(parentExcludeMarks, markName);
        }
        return false;
    }
    return true;
};
exports.checkMarkDisable = checkMarkDisable;
var checkSupportAttr = function (node, attrName) { return node.attrs[attrName] !== undefined; };
var checkParentSupportAttr = function (view, attrName) {
    var selection = view.state.selection;
    if (selection instanceof prosemirror_state_1.NodeSelection) {
        return checkSupportAttr(selection.node, attrName);
    }
    var $from = selection.$from, $to = selection.$to;
    var isSupport = checkSupportAttr(selection.$from.node(), attrName);
    if (!isSupport && $from.nodeAfter && $from.pos === $to.pos) {
        isSupport = checkSupportAttr($from.nodeAfter, attrName);
    }
    return isSupport;
};
exports.checkParentSupportAttr = checkParentSupportAttr;
var setAlign = function (view, align, inclusive) {
    if (inclusive === void 0) { inclusive = false; }
    var state = view.state, dispatch = view.dispatch;
    var tr = state.tr;
    var ranges = state.selection.ranges;
    if (!ranges.length)
        return false;
    ranges.forEach(function (range) {
        var from = range.$from.pos;
        var to = range.$to.pos;
        state.doc.nodesBetween(from, to, function (node, nodePos) {
            if (node.attrs.align !== undefined) {
                tr.setNodeMarkup(nodePos, undefined, __assign(__assign({}, node.attrs), { align: align }));
                return inclusive;
            }
        });
    });
    dispatch(tr);
    return true;
};
exports.setAlign = setAlign;
var checkParentHaveAttr = function (view, attrName, attrVal) {
    return view.state.selection.$from.parent.attrs[attrName] === attrVal;
};
exports.checkParentHaveAttr = checkParentHaveAttr;
// add user configuration to attrs attribute
var addAttrsByConfig = function (config, schema) {
    if (config === void 0) { config = {}; }
    if (!schema.attrs)
        schema.attrs = {};
    Object.keys(config).forEach(function (name) {
        Object.keys(config[name]).forEach(function (spec) {
            if (spec === 'getFromDOM' || spec === 'setDOMAttr')
                return;
            if (!schema.attrs[name])
                schema.attrs[name] = {};
            schema.attrs[name][spec] = config[name][spec];
        });
    });
};
exports.addAttrsByConfig = addAttrsByConfig;
// uses the default value when return undefined
var getFromDOMByConfig = function (config, dom, parseAttrs) {
    if (config === void 0) { config = {}; }
    return Object.keys(config).forEach(function (name) {
        var _a;
        var value = config[name].getFromDOM(dom);
        if (value !== undefined)
            Object.assign(parseAttrs, (_a = {}, _a[name] = value, _a));
    });
};
exports.getFromDOMByConfig = getFromDOMByConfig;
// used to construct dom in `toDOM`
var setDOMAttrByConfig = function (config, node, attrs) {
    if (config === void 0) { config = {}; }
    return Object.keys(config).forEach(function (name) { return config[name].setDOMAttr(node.attrs[name], attrs); });
};
exports.setDOMAttrByConfig = setDOMAttrByConfig;
// Keep the decimal point
var getFixSize = function (num, count) {
    if (count === void 0) { count = 3; }
    return Number(num.toFixed(count).replace(/\.?0+$/, ''));
};
exports.getFixSize = getFixSize;
var createFileInput = function (_a) {
    var _b = _a.multiple, multiple = _b === void 0 ? false : _b, accept = _a.accept, onChange = _a.onChange, _c = _a.getContainer, getContainer = _c === void 0 ? function () { return document.body; } : _c;
    var input = document.createElement('input');
    input.type = 'file';
    input.multiple = multiple;
    input.accept = accept;
    input.style.display = 'none';
    input.addEventListener('change', function (e) {
        onChange(e);
        e.target.value = '';
    });
    getContainer().appendChild(input);
    return input;
};
exports.createFileInput = createFileInput;
var isMatchObject = function (objStatic, objCompare) {
    if (objStatic === objCompare)
        return true;
    if (!(objStatic && typeof objStatic === 'object') || !(objCompare && typeof objCompare === 'object'))
        return false;
    var isArray = Array.isArray(objStatic);
    if (Array.isArray(objCompare) !== isArray)
        return false;
    if (isArray) {
        if (objStatic.length !== objCompare.length)
            return false;
        for (var i = 0; i < objStatic.length; i++)
            if (!isMatchObject(objStatic[i], objCompare[i]))
                return false;
    }
    else {
        for (var p in objStatic)
            if (!(p in objCompare) || !isMatchObject(objStatic[p], objCompare[p]))
                return false;
    }
    return true;
};
exports.isMatchObject = isMatchObject;
var keymapToggleMark = function (name) { return function (editor) {
    var _a;
    var isActive = editor.isActive(name);
    editor.setFormat((_a = {}, _a[name] = !isActive, _a));
    return true;
}; };
exports.keymapToggleMark = keymapToggleMark;
var simpleUploadHandler = function (config) { return __awaiter(void 0, void 0, void 0, function () {
    var name, target, uploader, getAttrs, uploadBeforeInsert, editor, file, index, url, attrs;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                name = config.name, target = config.target, uploader = config.uploader, getAttrs = config.getAttrs, uploadBeforeInsert = config.uploadBeforeInsert, editor = config.editor;
                if (!target.files || !target.files.length)
                    return [2 /*return*/];
                file = target.files[0];
                index = editor.getSelection().index;
                url = '';
                if (!uploadBeforeInsert) {
                    url = URL.createObjectURL(file);
                    editor.insertCard(name, getAttrs(url, file), index);
                }
                return [4 /*yield*/, uploader(file, editor)];
            case 1:
                attrs = _a.sent();
                if (!uploadBeforeInsert) {
                    index = -1;
                    editor.getExistNodes(name).some(function (val) {
                        if (val.node.attrs.src === url) {
                            index = val.pos;
                            editor.delete(val.pos, 1, { addToHistory: false });
                            return true;
                        }
                    });
                }
                if (attrs && index > -1) {
                    index > -1 && editor.insertCard(name, attrs, index);
                }
                url && URL.revokeObjectURL(url);
                return [2 /*return*/];
        }
    });
}); };
exports.simpleUploadHandler = simpleUploadHandler;
//# sourceMappingURL=tools.js.map